using System;

/// @author  Vesa Lappalainen
/// @version 10.10.2011
///
/// <summary>
/// Esimerkkejä matriisista
/// </summary>
public class Matriisit
{
    /// <summary>
    /// Esimerkkejä matriiseista
    /// </summary>
    public static void Main()
    {
        // int[] luvut = int[3];
        // int[] luvut = new int[]{ 3, 5, 1, 9 };

        int[,] matriisi1 = new int[4, 5];

        int[,] matriisi = {
            {1,2,3},
            {4,5,6},
            {7,8,9},
            {10,11,12}
        };

        Tulosta(matriisi);

        Console.WriteLine("Dimensio: " + matriisi.Rank);
        Console.WriteLine("Rivejä: " + matriisi.GetLength(0));
        Console.WriteLine("Sarakkeita: " + matriisi.GetLength(1));
        Console.WriteLine("Paikassa 2,1: " + matriisi[2, 1]);

        int rivi = MiltaRiviltaLoytyy(matriisi, 8);
        Console.WriteLine($"Löytyi riviltä {rivi}");
        
        matriisi1[3, 2] = 99;

        Tulosta(matriisi1);
    }


    /// <summary>
    /// Etsitään miltä riviltä löytyy etsittävä luku
    /// </summary>
    /// <param name="mat">Matriisi josta etsitään</param>
    /// <param name="etsittava">luku jota etsitään</param>
    /// <returns>rivi, jolta luku löytyy.  Jos usealla rivillä, palautetaan 1. indeksi.
    /// jos ei löydy lainkaan, palautetaan -1.</returns>
    /// <example>
    /// <pre name="test">
    /// int[,] m = {{2,4,1},{9,2,0},{5,6,1},{0,12,3}};
    /// MiltaRiviltaLoytyy(m,1) === 0;
    /// MiltaRiviltaLoytyy(m,0) === 1;
    /// MiltaRiviltaLoytyy(m,12) === 3;
    /// MiltaRiviltaLoytyy(m,11) === -1;
    /// </pre>
    /// </example>

    public static int MiltaRiviltaLoytyy(int[,] mat, int etsittava)
    {
        int riveja = mat.GetLength(0);
        int sarkkeita = mat.GetLength(1);

        for (int iy = 0; iy < riveja; iy++)
        {
            for (int ix = 0; ix < sarkkeita; ix++)
            {
                int luku = mat[iy, ix];
                if (luku == etsittava) return iy;
            }
        }
        
        return -1;
    }
    
    
    
    /// <summary>
    /// Tulostetaan matriisin alkiot riveittäin.
    /// Kukin alkio vie kahden merkin kokoisen tilan.
    /// </summary>
    /// <param name="mat">tulostettava matriisi</param>
    public static void Tulosta(int[,] mat)
    {
        
    }

}