using System;
using System.Text;

/// @author  Vesa Lappalainen
/// @version 30.09.2011
/// 
/// <summary>
/// Tutkitaan olioviitteiden käyttöä ja käyttäytymistä.
/// </summary>
public class Olioviitteet
{
    /// <summary>
    /// Alustetaan muuttujia ja tulostetaan. 
    /// Testaillaan olioiden ja alkeismuuttujien eroja.
    /// </summary>
    public static void Main()
    {
        StringBuilder s1 = new StringBuilder("eka");
        StringBuilder s2 = new StringBuilder("eka");

        Console.WriteLine(s1 == s2);         // false
        Console.WriteLine(s1.Equals(s2));    // true
        Console.WriteLine(s1.Equals("eka")); // true
        Console.WriteLine(s1.ToString().Equals("eka")); // true

        int i1 = 11;
        int i2 = 10 + 1;

        Console.WriteLine(i1 == i2);         // true

        int[] it1 =  new int[]{3};
        int[] it2 = { 3 };

        Console.WriteLine(it1 == it2);       // false
        Console.WriteLine(it1.Equals(it2));  // false

        Console.WriteLine(it1[0] == it2[0]); // true

        s2 = s1;
        Console.WriteLine(s1 == s2);         // true

        // ==========================================================

        string st1 = "eka";
        string st2 = s1.ToString();

        Console.WriteLine(Object.ReferenceEquals(st1, st2)); // false
        Console.WriteLine(st1 == st2);       // true
        Console.WriteLine(st1.Equals(st2));  // true
        Console.WriteLine(object.ReferenceEquals(st1, st2)); // false

        st2 = null;
        Console.WriteLine(st2 == null);       // true
        Console.WriteLine(object.ReferenceEquals(st1, st2)); // false
        st1 = null;
        Console.WriteLine(object.ReferenceEquals(st1, st2)); // true
    }
}