using System;
using NUnit.Framework;
using static SuurinJaPienin;

	[TestFixture]
	[DefaultFloatingPointTolerance(0.000001)]
	public  class TestSuurinJaPienin
	{
		[Test]
		public  void TestPienin51()
		{
			Assert.AreEqual( 1, Pienin(new int[]{1, 2 ,3}) , "in method Pienin, line 52");
			Assert.AreEqual( 1, Pienin(new int[]{1, 3 ,2}) , "in method Pienin, line 53");
			Assert.AreEqual( 1, Pienin(new int[]{2, 1, 3}) , "in method Pienin, line 54");
			Assert.AreEqual( 1, Pienin(new int[]{2, 3, 1}) , "in method Pienin, line 55");
			Assert.AreEqual( 1, Pienin(new int[]{3, 1 ,2}) , "in method Pienin, line 56");
			Assert.AreEqual( 1, Pienin(new int[]{3, 2 ,1}) , "in method Pienin, line 57");
			Assert.AreEqual( 2, Pienin(new int[]{3, 3, 2}) , "in method Pienin, line 58");
			Assert.AreEqual( 3, Pienin(new int[]{3, 3, 3}) , "in method Pienin, line 59");
			Assert.AreEqual( 1, Pienin(new int[]{1, 2})    , "in method Pienin, line 60");
			Assert.AreEqual( 2, Pienin(new int[]{2})       , "in method Pienin, line 61");
			Assert.AreEqual( int.MaxValue, Pienin(new int[]{})        , "in method Pienin, line 62");
		}
		[Test]
		public  void TestSuurin82()
		{
			Assert.AreEqual( 3, Suurin(new int[]{1, 2 ,3}) , "in method Suurin, line 83");
			Assert.AreEqual( 3, Suurin(new int[]{1, 3 ,2}) , "in method Suurin, line 84");
			Assert.AreEqual( 3, Suurin(new int[]{2, 1, 3}) , "in method Suurin, line 85");
			Assert.AreEqual( 3, Suurin(new int[]{2, 3, 1}) , "in method Suurin, line 86");
			Assert.AreEqual( 3, Suurin(new int[]{3, 1 ,2}) , "in method Suurin, line 87");
			Assert.AreEqual( 3, Suurin(new int[]{3, 2 ,1}) , "in method Suurin, line 88");
			Assert.AreEqual( 4, Suurin(new int[]{4, 2, 4}) , "in method Suurin, line 89");
			Assert.AreEqual( 1, Suurin(new int[]{1, 1, 1}) , "in method Suurin, line 90");
			Assert.AreEqual( 2, Suurin(new int[]{1, 2   }) , "in method Suurin, line 91");
			Assert.AreEqual( 1, Suurin(new int[]{1      }) , "in method Suurin, line 92");
			Assert.AreEqual( 0, Suurin(new int[]{       }) , "in method Suurin, line 93");
		}
		[Test]
		public  void TestPienin3116()
		{
			Assert.AreEqual( 1, Pienin3(new int[]{1, 2 ,3}) , "in method Pienin3, line 117");
			Assert.AreEqual( 1, Pienin3(new int[]{1, 3 ,2}) , "in method Pienin3, line 118");
			Assert.AreEqual( 1, Pienin3(new int[]{2, 1, 3}) , "in method Pienin3, line 119");
			Assert.AreEqual( 1, Pienin3(new int[]{2, 3, 1}) , "in method Pienin3, line 120");
			Assert.AreEqual( 1, Pienin3(new int[]{3, 1 ,2}) , "in method Pienin3, line 121");
			Assert.AreEqual( 1, Pienin3(new int[]{3, 2 ,1}) , "in method Pienin3, line 122");
			Assert.AreEqual( 2, Pienin3(new int[]{3, 3, 2}) , "in method Pienin3, line 123");
			Assert.AreEqual( 3, Pienin3(new int[]{3, 3, 3}) , "in method Pienin3, line 124");
		}
		[Test]
		public  void TestSuurin3145()
		{
			Assert.AreEqual( 3, Suurin3(new int[]{1, 2 ,3}) , "in method Suurin3, line 146");
			Assert.AreEqual( 3, Suurin3(new int[]{1, 3 ,2}) , "in method Suurin3, line 147");
			Assert.AreEqual( 3, Suurin3(new int[]{2, 1, 3}) , "in method Suurin3, line 148");
			Assert.AreEqual( 3, Suurin3(new int[]{2, 3, 1}) , "in method Suurin3, line 149");
			Assert.AreEqual( 3, Suurin3(new int[]{3, 1 ,2}) , "in method Suurin3, line 150");
			Assert.AreEqual( 3, Suurin3(new int[]{3, 2 ,1}) , "in method Suurin3, line 151");
			Assert.AreEqual( 4, Suurin3(new int[]{4, 2, 4}) , "in method Suurin3, line 152");
			Assert.AreEqual( 1, Suurin3(new int[]{1, 1, 1}) , "in method Suurin3, line 153");
			try
			{
			Assert.AreEqual( 1, Suurin3(new int[]{1, 1   }) , "in method Suurin3, line 154");
			Assert.Fail("Did not throw IndexOutOfRangeException in method Suurin3 on line 153");
			}
			catch (IndexOutOfRangeException)
			{
			}
			Assert.IsTrue( System.Text.RegularExpressions.Regex.Matches(("ABC" ).ToString(), ( "A.C").ToString()).Count > 0, "in method Suurin3, line 155 with actual value [" + "ABC"  + "]" );
		}
		[Test]
		public  void TestSuurimmanPaikka173()
		{
			int[] luvut = {2,5,4,3};
			Assert.AreEqual( 1, SuurimmanPaikka(luvut) , "in method SuurimmanPaikka, line 175");
			Assert.AreEqual( 0, SuurimmanPaikka(new int[]{3,2,1}) , "in method SuurimmanPaikka, line 176");
			Assert.AreEqual( 1, SuurimmanPaikka(new int[]{3,4,1}) , "in method SuurimmanPaikka, line 177");
			Assert.AreEqual( 2, SuurimmanPaikka(new int[]{3,2,5}) , "in method SuurimmanPaikka, line 178");
			Assert.AreEqual( 0, SuurimmanPaikka(new int[]{3}) , "in method SuurimmanPaikka, line 179");
			Assert.AreEqual( -1, SuurimmanPaikka(new int[]{}) , "in method SuurimmanPaikka, line 180");
		}
		[Test]
		public  void TestVaihdaSuurin206()
		{
			int[] luvut = {2,5,4,3};
			VaihdaSuurin(luvut,1);
			Assert.AreEqual( "2 1 4 3", String.Join(" ",luvut) , "in method VaihdaSuurin, line 209");
			VaihdaSuurin(luvut,1);
			Assert.AreEqual( "2 1 1 3", String.Join(" ",luvut) , "in method VaihdaSuurin, line 211");
			VaihdaSuurin(luvut,9);
			Assert.AreEqual( "2 1 1 9", String.Join(" ",luvut) , "in method VaihdaSuurin, line 213");
			VaihdaSuurin(luvut,1);
			Assert.AreEqual( "2 1 1 1", String.Join(" ",luvut) , "in method VaihdaSuurin, line 215");
			VaihdaSuurin(luvut,-1);
			Assert.AreEqual( "-1 1 1 1", String.Join(" ",luvut) , "in method VaihdaSuurin, line 217");
			luvut = new int[]{5};
			VaihdaSuurin(luvut,2);
			Assert.AreEqual( "2", String.Join(" ",luvut) , "in method VaihdaSuurin, line 220");
			luvut = new int[0];
			VaihdaSuurin(luvut,2);
			Assert.AreEqual( "", String.Join(" ",luvut) , "in method VaihdaSuurin, line 223");
		}
		[Test]
		public  void TestTayta240()
		{
			int[] luvut = {1,2,3,4};
			Tayta(luvut,5);
			Assert.AreEqual( "5 5 5 5", String.Join(" ",luvut) , "in method Tayta, line 243");
		}
		[Test]
		public  void TestEtsi264()
		{
			int[] luvut = {1,2,3,4,3,2,0};
			Assert.AreEqual( -1, Etsi(luvut,5) , "in method Etsi, line 266");
			Assert.AreEqual( 3, Etsi(luvut,4) , "in method Etsi, line 267");
			Assert.AreEqual( 0, Etsi(luvut,1) , "in method Etsi, line 268");
			Assert.AreEqual( 6, Etsi(luvut,0) , "in method Etsi, line 269");
			Assert.AreEqual( 1, Etsi(luvut,2) , "in method Etsi, line 270");
			Assert.AreEqual( -1, Etsi(new int[]{},1) , "in method Etsi, line 271");
		}
	}

